require 'rufus-scheduler'

class Robut::Plugin::Cron
  include Robut::Plugin
  
  @@skeds = Hash.new
      
  # Returns a description of how to use this plugin
  def usage
    ["#{at_nick} cron new * * * * * <message> - will send this message on the cron schedule",
     "#{at_nick} cron list - will return the list of job ids",
     "#{at_nick} cron stop <id> - will remove a job"]
  end
  def handle(time, sender_nick, message)
    if sent_to_me?(message) && !message.include?(" - ") && !message.include?("help")
      # Need to separate the cron schedule from the message
      # @bo cron '* * * * *' message
                    
      a = message.split(" ")
      if a[1] == "cron"
        command = a[2]
        
        case command
        when "new"  
          create(a[3..7].join(" "), a[8..a.count()-1].join(" "))
        when "list"
          reply list
        when "stop"
          reply stop(a[3..a.count()-1].join(" "))
        when "load"
          load_from_file(a[3..a.count()-1].join(" "))
        else 
          reply "i don't understand that cron command"
        end
      end       
    end
  end
  
  def create(cron, message)
    begin
      scheduler = Rufus::Scheduler.start_new
      job = scheduler.cron cron do |job|
  
        if @@skeds.has_value? job.t
          connection = self.connection
          reply(message)
        else
          job.unschedule
        end

      end
      @@skeds[message] = job.t
      store['jobs'] ||= []
      store['jobs'] = @@skeds
      reply "new cron job with id: #{message}"
    rescue ArgumentError
      reply "argument error, perhaps the cronline?"
    end
  end
  
  def list()
    if @@skeds.empty?
      "no jobs!"
    else
      r = ""
      store['jobs'].each do |k,v|
        r = r + "[#{v}:#{k}] "
      end
      r
    end
  end
  
  def stop(id)
    if @@skeds.has_key?(id)
      @@skeds.delete(id)
      store['jobs'] ||= []
      store['jobs'] = @@skeds
      "stopping #{id}"
    else
      "invalid id: #{id}, can't stop that"
    end
  end
  
  # load the jobs from the .robut store
  # it's a bit of a chicken/egg prob so we'll
  # create if it doesn't exist and leave 
  # it empty.
  def load_from_file(file)
    if !File.exist? file
      reply "file does not exist"
    else
      begin
        s = YAML.load_file(file)
        if s
          s['jobs'].each do |key, val|
            create val,key
          end
        else
          reply "not a valid robut config file"
        end
      rescue
        reply "not a valid robut config file"
      end
    end
  end
  
end

